SystemOrganization addCategory: #'CS528-SetbackProject-Tests'!

TestCase subclass: #SetbackTestCase
	instanceVariableNames: 'sortedDeck oneHeart oneDiamond oneClub oneSpade player1 player2 player3 player4 ll'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

SetbackTestCase subclass: #CardHandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!CardHandTest methodsFor: 'tests' stamp: 'TerryTata 6/30/2013 12:11'!
testHandAdditionCapacity
|hand deck|
deck:= (FrenchDeck createStandardDeck).
hand:= (SetbackPlayerHand addCard: deck dealNext).
self assert: (hand cards size) = 1.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 2.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 3.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 4.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 5.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 6.
self should: [ (hand addCard: deck dealNext). ] raise: TestResult error.
! !

!CardHandTest methodsFor: 'tests' stamp: 'TerryTata 6/30/2013 12:11'!
testHandRemovalCapacity
|hand card|
card:= (Card value: #two suit: #hearts).
hand:= (SetbackPlayerHand addCard: card).
self assert: (hand capacity) = 6.
self assert: (hand cards size) = 1.
(hand removeCard: card).
self should: [ (hand removeCard: card). ] raise: TestResult error.
! !

!CardHandTest methodsFor: 'tests' stamp: 'TerryTata 6/30/2013 12:11'!
testHandUniqueness
|hand card|
card:= (Card value: #two suit: #hearts).
hand:= (SetbackPlayerHand addCard: card).
self assert: (hand capacity) = 6.
self assert: (hand cards size) = 1.
(SetbackPlayerHand addCard: card).
self assert: (hand cards size) = 1.! !

SetbackTestCase subclass: #CardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!CardTest methodsFor: 'tests' stamp: 'TerryTata 6/29/2013 11:07'!
testCardUniqueness
|card|
card:= (Card value: #two suit: #hearts).
self should: [ card value: #two suit: #hearts ] raise: TestResult error.! !

!CardTest methodsFor: 'tests' stamp: 'TerryTata 6/28/2013 15:29'!
testInvalidCardCreation
self should: [(Card value: #two unit: #two)] raise: TestResult error.
self should: [(Card value: #hearts unit: #hearts)] raise: TestResult error.! !

!CardTest methodsFor: 'tests' stamp: 'TerryTata 6/29/2013 11:07'!
testSimpleCardCreation
self assert: ((Card value: #two suit: #hearts) value) = #two.
self assert: ((Card value: #two suit: #hearts) suit) = #hearts.! !

SetbackTestCase subclass: #DeckTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!DeckTest methodsFor: 'tests' stamp: 'TerryTata 6/30/2013 07:58'!
testDeckCreation
self assert: (FrenchDeck new cards = nil).
self assert: (FrenchDeck createStandardDeck cards size = 52).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #ace suit: #hearts)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #king suit: #diamonds)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #queen suit: #spades)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #jack suit: #clubs)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #ten suit: #hearts)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #nine suit: #diamonds)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #eight suit: #spades)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #seven suit: #clubs)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #six suit: #clubs)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #five suit: #hearts)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #four suit: #diamonds)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #three suit: #spades)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #two suit: #clubs)).! !

!DeckTest methodsFor: 'tests' stamp: 'TerryTata 6/30/2013 07:58'!
testDeckDealing
|deck|
deck:= FrenchDeck createStandardDeck.
1 to: 52 do: [ :i | deck dealNext ].
self should: [deck dealNext] raise: TestResult error.! !

!DeckTest methodsFor: 'tests' stamp: 'TerryTata 7/19/2013 07:48'!
testDeckSingleton
|deck|
deck:= FrenchDeck createStandardDeck.
self assert: deck cards size = 52.
self assert: deck currentIndex = 0.! !

SetbackTestCase subclass: #SetbackGameTest
	instanceVariableNames: 'game hand team1 team2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!SetbackGameTest methodsFor: 'setUp' stamp: 'TerryTata 7/23/2013 19:39'!
setUpWithDifferentWinStrategy
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
(ll add: player3).
game:= SetbackGame config: (ThreePlayerStrategy new) winner: (FirstToElevenWinStrategy new) order: (SetbackPhaseOrder new).
game addPlayer: player1.
game addPlayer: player2.
game addPlayer: player3.
hand:= game startGame.
hand startNextPhase.
hand startNextPhase.
player2 makeBid: #two.
player3 makeBid: #pass.
player1 makeBid: #two.
"player one wins the bid"! !

!SetbackGameTest methodsFor: 'setUp' stamp: 'TerryTata 7/23/2013 19:45'!
setUpWithNoJunkPoints
|phaseOrder|
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
(ll add: player3).
phaseOrder:= SetbackPhaseOrder new.
phaseOrder scorePhase: #NoGarbagePointsScorePhase.
game:= SetbackGame config: (ThreePlayerStrategy new) winner: (StandardWinStrategy  new) order: phaseOrder.
game addPlayer: player1.
game addPlayer: player2.
game addPlayer: player3.
hand:= game startGame.
hand startNextPhase.
hand startNextPhase.
player2 makeBid: #two.
player3 makeBid: #pass.
player1 makeBid: #two.
"player one wins the bid"! !

!SetbackGameTest methodsFor: 'setUp' stamp: 'TerryTata 7/12/2013 13:36'!
standardDealAndBidPhases
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
(ll add: player3).
game:= SetbackGame setUpStandardGame.
game addPlayer: player1.
game addPlayer: player2.
game addPlayer: player3.
hand:= game startGame.
hand startNextPhase.
hand startNextPhase.
player2 makeBid: #two.
player3 makeBid: #pass.
player1 makeBid: #two.
"player one wins the bid"! !

!SetbackGameTest methodsFor: 'setUp' stamp: 'TerryTata 7/12/2013 13:36'!
standardTrickAndScorePhases
player1 hand: oneClub copy.
player2 hand: oneSpade copy.
player3 hand: oneDiamond copy.
hand startNextPhase.
"hearts as trump - player 2 wins trick"
player1 playCard: (sortedDeck at: 18).
player2 playCard: (sortedDeck at: 22).
player3 playCard: (sortedDeck at: 10).
"trick 2 - player 2 wins"
player1 playCard: (sortedDeck at: 13).
"we shouldn't be listening to player 1, only player 2 who is next to throw"
self assert: (player1 hand cards size) =  5.
player2 playCard: (sortedDeck at: 25).
player3 playCard: (sortedDeck at: 41).
player1 playCard: (sortedDeck at: 17).
"trick 3 - player 2 wins"
player2 playCard: (sortedDeck at: 19).
player3 playCard: (sortedDeck at: 11).
player1 playCard: (sortedDeck at: 15).
"trick 4 - player 3 wins"
player2 playCard: (sortedDeck at: 20).
player3 playCard: (sortedDeck at: 8).
player1 playCard: (sortedDeck at: 16).
"trick 5 - player 3 wins"
player3 playCard: (sortedDeck at: 12).
player1 playCard: (sortedDeck at: 13).
player2 playCard: (sortedDeck at: 21).
"trick 6 - player 3 wins"
player3 playCard: (sortedDeck at: 50).
player1 playCard: (sortedDeck at: 14).
player2 playCard: (sortedDeck at: 23).
hand startNextPhase.
hand startNextPhase.! !

!SetbackGameTest methodsFor: 'setUp' stamp: 'TerryTata 7/12/2013 16:02'!
teamDealAndBidPhases
team1:= SetbackPlayerTeam new.
team2:= SetbackPlayerTeam new.
player1 joinTeam: team1.
player2 joinTeam: team2.
player3 joinTeam: team1.
player4 joinTeam: team2.
game:= SetbackGame setUpStandardTeamGame.
game addPlayer: player1.
game addPlayer: player2.
game addPlayer: player3.
game addPlayer: player4.
hand:= game startGame.
hand startNextPhase.
hand startNextPhase.
player2 makeBid: #two.
player3 makeBid: #pass.
player4 makeBid: #pass.
player1 makeBid: #two.
"player1 wins the bid"! !

!SetbackGameTest methodsFor: 'setUp' stamp: 'TerryTata 7/13/2013 09:39'!
teamTrickAndScorePhases
player1 hand: oneClub.
player2 hand: oneSpade.
player3 hand: oneDiamond.
player4 hand: oneHeart.
hand startNextPhase.
"hearts as trump - player 2 wins trick"
player1 playCard: (sortedDeck at: 18).
player2 playCard: (sortedDeck at: 22).
player3 playCard: (sortedDeck at: 10).
player4 playCard: (sortedDeck at: 2).
"trick 2 - player 2 wins"
player1 playCard: (sortedDeck at: 13).
"we shouldn't be listening to player 1, only player 2 who is next to throw"
self assert: (player1 hand cards size) =  5.
player2 playCard: (sortedDeck at: 25).
player3 playCard: (sortedDeck at: 41).
player4 playCard: (sortedDeck at: 5).
player1 playCard: (sortedDeck at: 17).
"trick 3 - player 2 wins"
player2 playCard: (sortedDeck at: 19).
player3 playCard: (sortedDeck at: 11).
player4 playCard: (sortedDeck at: 3).
player1 playCard: (sortedDeck at: 15).
"trick 4 - player 3 wins"
player2 playCard: (sortedDeck at: 20).
player3 playCard: (sortedDeck at: 8).
player4 playCard: (sortedDeck at: 4).
player1 playCard: (sortedDeck at: 16).
"trick 5 - player 4 wins"
player3 playCard: (sortedDeck at: 12).
player4 playCard: (sortedDeck at: 28).
player1 playCard: (sortedDeck at: 13).
player2 playCard: (sortedDeck at: 21).
"trick 6 - player 3 wins"
player4 playCard: (sortedDeck at: 1).
player1 playCard: (sortedDeck at: 14).
player2 playCard: (sortedDeck at: 23).
player3 playCard: (sortedDeck at: 50).
hand startNextPhase.
hand startNextPhase.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/12/2013 15:09'!
testBasicTeamTrickPhase
self teamDealAndBidPhases.
player1 hand: oneClub.
player2 hand: oneSpade.
player3 hand: oneDiamond.
player4 hand: oneHeart.
hand startNextPhase.
"hearts as trump"
player1 playCard: (sortedDeck at: 18).
self assert: (player1 hand cards size) =  5.
"can't play diamonds"
self should: [player2 playCard: (sortedDeck at: 21)] raise: TestResult error.
player2 playCard: (sortedDeck at: 22).
self assert: (player2 hand cards size) =  5.
player3 playCard: (sortedDeck at: 10).
self assert: (player3 hand cards size) =  5.
player4 playCard: (sortedDeck at: 2).
self assert: (player4 hand cards size) =  5.
"the trick is over according to our player configuration"
self assert: (player2 cardsWon size) = 4.
! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/12/2013 13:36'!
testBasicTrickPhase
self standardDealAndBidPhases.
player1 hand: oneClub.
player2 hand: oneSpade.
player3 hand: oneDiamond.
hand startNextPhase.
"hearts as trump"
player1 playCard: (sortedDeck at: 18).
self assert: (player1 hand cards size) =  5.
"can't play diamonds"
self should: [player2 playCard: (sortedDeck at: 21)] raise: TestResult error.
player2 playCard: (sortedDeck at: 22).
self assert: (player2 hand cards size) =  5.
player3 playCard: (sortedDeck at: 10).
self assert: (player3 hand cards size) =  5.
"the trick is over according to our player configuration"
self assert: (player2 cardsWon size) = 3.
! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/21/2013 11:37'!
testCokeHand
self standardDealAndBidPhases.
player1 hand: oneClub.
player2 hand: oneSpade.
player3 hand: oneDiamond.
player4 hand: oneHeart.

self assert: (player1 hasCokeHand) = true.
self assert: (player2 hasCokeHand) = false.
self assert: (player3 hasCokeHand) = false.
self assert: (player4 hasCokeHand) = false.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/12/2013 14:57'!
testDealAndBidWithTeams
| team1 team2|
team1:= SetbackPlayerTeam new.
team2:= SetbackPlayerTeam new.
player1 joinTeam: team1.
player2 joinTeam: team2.
player3 joinTeam: team1.
player4 joinTeam: team2.
game:= SetbackGame setUpStandardTeamGame.
game addPlayer: player1.
game addPlayer: player2.
game addPlayer: player3.
game addPlayer: player4.
hand:= game startGame.
hand startNextPhase.
hand startNextPhase.
player2 makeBid: #pass.
player3 makeBid: #pass.
player4 makeBid: #pass.
player1 makeBid: #pass.
self assert: hand bidder = player1. 
self assert: hand currentBid = #two. 
self assert: player1 hand cards size = 6.
self assert: player2 hand cards size = 6.
self assert: player3 hand cards size = 6.
self assert: player4 hand cards size = 6.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/13/2013 09:30'!
testFullTeamTrickPhase
self teamDealAndBidPhases.
player1 hand: oneClub.
player2 hand: oneSpade.
player3 hand: oneDiamond.
player4 hand: oneHeart.
hand startNextPhase.
"hearts as trump - player 2 wins trick"
player1 playCard: (sortedDeck at: 18).
player2 playCard: (sortedDeck at: 22).
player3 playCard: (sortedDeck at: 10).
player4 playCard: (sortedDeck at: 2).
"trick 2 - player 2 wins"
player1 playCard: (sortedDeck at: 13).
"we shouldn't be listening to player 1, only player 2 who is next to throw"
self assert: (player1 hand cards size) =  5.
player2 playCard: (sortedDeck at: 25).
player3 playCard: (sortedDeck at: 41).
player4 playCard: (sortedDeck at: 5).
player1 playCard: (sortedDeck at: 17).
"trick 3 - player 2 wins"
player2 playCard: (sortedDeck at: 19).
player3 playCard: (sortedDeck at: 11).
player4 playCard: (sortedDeck at: 3).
player1 playCard: (sortedDeck at: 15).
"trick 4 - player 3 wins"
player2 playCard: (sortedDeck at: 20).
player3 playCard: (sortedDeck at: 8).
player4 playCard: (sortedDeck at: 4).
player1 playCard: (sortedDeck at: 16).
"trick 5 - player 4 wins"
player3 playCard: (sortedDeck at: 12).
player4 playCard: (sortedDeck at: 28).
player1 playCard: (sortedDeck at: 13).
player2 playCard: (sortedDeck at: 21).
"trick 6 - player 3 wins"
player4 playCard: (sortedDeck at: 1).
player1 playCard: (sortedDeck at: 14).
player2 playCard: (sortedDeck at: 23).
player3 playCard: (sortedDeck at: 50).

self assert: (player1 hand cards size) = 0.
self assert: (player2 hand cards size) = 0.
self assert: (player3 hand cards size) = 0.
self assert: (player4 hand cards size) = 0.
self assert: (player1 cardsWon size) = 0.
self assert: (player2 cardsWon size) = 12.
self assert: (player3 cardsWon size) = 8.
self assert: (player4 cardsWon size) = 4.
self assert: (hand trump) = #hearts.
hand startNextPhase.
hand startNextPhase.
self assert: player1 pointsEarned + player3 pointsEarned = -2.
self assert: player2 pointsEarned + player4  pointsEarned = 2.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/12/2013 13:36'!
testFullTrickPhase
self standardDealAndBidPhases.
player1 hand: oneClub.
player2 hand: oneSpade.
player3 hand: oneDiamond.
hand startNextPhase.
"hearts as trump - player 2 wins trick"
player1 playCard: (sortedDeck at: 18).
player2 playCard: (sortedDeck at: 22).
player3 playCard: (sortedDeck at: 10).
"trick 2 - player 2 wins"
player1 playCard: (sortedDeck at: 13).
"we shouldn't be listening to player 1, only player 2 who is next to throw"
self assert: (player1 hand cards size) =  5.
player2 playCard: (sortedDeck at: 25).
player3 playCard: (sortedDeck at: 41).
player1 playCard: (sortedDeck at: 17).
"trick 3 - player 2 wins"
player2 playCard: (sortedDeck at: 19).
player3 playCard: (sortedDeck at: 11).
player1 playCard: (sortedDeck at: 15).
"trick 4 - player 3 wins"
player2 playCard: (sortedDeck at: 20).
player3 playCard: (sortedDeck at: 8).
player1 playCard: (sortedDeck at: 16).
"trick 5 - player 3 wins"
player3 playCard: (sortedDeck at: 12).
player1 playCard: (sortedDeck at: 13).
player2 playCard: (sortedDeck at: 21).
"trick 6 - player 3 wins"
player3 playCard: (sortedDeck at: 50).
player1 playCard: (sortedDeck at: 14).
player2 playCard: (sortedDeck at: 23).

self assert: (player1 hand cards size) = 0.
self assert: (player2 hand cards size) = 0.
self assert: (player3 hand cards size) = 0.
self assert: (player1 cardsWon size) = 0.
self assert: (player2 cardsWon size) = 9.
self assert: (player3 cardsWon size) = 9.
self assert: (hand trump) = #hearts.
hand startNextPhase.
hand startNextPhase.
self assert: player1 pointsEarned = -2.
self assert: player2 pointsEarned = 1.
self assert: player3  pointsEarned = 2.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/23/2013 19:45'!
testFullTrickPhaseNoJunk
self setUpWithNoJunkPoints.
player1 hand: oneClub.
player2 hand: oneSpade.
player3 hand: oneDiamond.
hand startNextPhase.
"hearts as trump - player 2 wins trick"
player1 playCard: (sortedDeck at: 18).
player2 playCard: (sortedDeck at: 22).
player3 playCard: (sortedDeck at: 10).
"trick 2 - player 2 wins"
player1 playCard: (sortedDeck at: 13).
"we shouldn't be listening to player 1, only player 2 who is next to throw"
self assert: (player1 hand cards size) =  5.
player2 playCard: (sortedDeck at: 25).
player3 playCard: (sortedDeck at: 41).
player1 playCard: (sortedDeck at: 17).
"trick 3 - player 2 wins"
player2 playCard: (sortedDeck at: 19).
player3 playCard: (sortedDeck at: 11).
player1 playCard: (sortedDeck at: 15).
"trick 4 - player 3 wins"
player2 playCard: (sortedDeck at: 20).
player3 playCard: (sortedDeck at: 8).
player1 playCard: (sortedDeck at: 16).
"trick 5 - player 3 wins"
player3 playCard: (sortedDeck at: 12).
player1 playCard: (sortedDeck at: 13).
player2 playCard: (sortedDeck at: 21).
"trick 6 - player 3 wins"
player3 playCard: (sortedDeck at: 50).
player1 playCard: (sortedDeck at: 14).
player2 playCard: (sortedDeck at: 23).

self assert: (player1 hand cards size) = 0.
self assert: (player2 hand cards size) = 0.
self assert: (player3 hand cards size) = 0.
self assert: (player1 cardsWon size) = 0.
self assert: (player2 cardsWon size) = 9.
self assert: (player3 cardsWon size) = 9.
self assert: (hand trump) = #hearts.
hand startNextPhase.
hand startNextPhase.
self assert: player1 pointsEarned = -2.
self assert: player2 pointsEarned = 0.
self assert: player3  pointsEarned = 0.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/7/2013 17:09'!
testGameCreation
|game|
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
player3:= SetbackPlayer name: 'Adam'.
game:= SetbackGame setUpStandardGame.
game addPlayer: player1.
game addPlayer: player2.
game addPlayer: player3.
game startGame.

self assert: game started = true.
! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/12/2013 14:52'!
testGameCreationTeams
| team1 team2|
team1:= SetbackPlayerTeam new.
team2:= SetbackPlayerTeam new.
player1 joinTeam: team1.
player2 joinTeam: team2.
player3 joinTeam: team1.
player4 joinTeam: team2.
game:= SetbackGame setUpStandardTeamGame.
game addPlayer: player1.
game addPlayer: player2.
game addPlayer: player3.
game addPlayer: player4.
game startGame.

self assert: game started = true.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/27/2013 11:44'!
testGameStartAndBid
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
player3:= SetbackPlayer name: 'Adam'.
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
(ll add: player3).
hand:= SetbackGameHand players: ll playerConfig: nil winnerStrat: nil phaseOrder: (SetbackPhaseOrder new).
hand startNextPhase.
hand startNextPhase.
player2 makeBid: #pass.
player3 makeBid: #pass.
player1 makeBid: #pass.
self assert: hand bidder = player1. 
self assert: hand currentBid = #two. ! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/27/2013 11:44'!
testGameStartAndBid2
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
player3:= SetbackPlayer name: 'Adam'.
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
(ll add: player3).
hand:= SetbackGameHand players: ll playerConfig: nil winnerStrat: nil phaseOrder: (SetbackPhaseOrder new).
hand startNextPhase.
hand startNextPhase.
player2 makeBid: #two.
player3 makeBid: #three.
player1 makeBid: #two.
self assert: hand bidder = player3. 
self assert: hand currentBid = #three. ! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/27/2013 11:44'!
testGameStartAndDealerStealsBid
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
player3:= SetbackPlayer name: 'Adam'.
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
(ll add: player3).
hand:= SetbackGameHand players: ll playerConfig: nil winnerStrat: nil phaseOrder: (SetbackPhaseOrder new).
hand startNextPhase.
hand startNextPhase.
player2 makeBid: #two.
player3 makeBid: #pass.
player1 makeBid: #two.
self assert: hand bidder = player1. 
self assert: hand currentBid = #two. ! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/12/2013 13:36'!
testGameWinner
self standardDealAndBidPhases.
player1 addToPointsEarned: 15.
self standardTrickAndScorePhases.
self assert: (player1 gamesWon) = 1.
self assert: (player2 gamesWon) = 0.
self assert: (player3 gamesWon) = 0.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/12/2013 13:43'!
testGameWinnerAlt
self setUpWithDifferentWinStrategy.
player2 addToPointsEarned: 9.
player3 addToPointsEarned: 9.
self standardTrickAndScorePhases.
self assert: (player1 gamesWon) = 0.
self assert: (player2 gamesWon) = 0.
self assert: (player3 gamesWon) = 1.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/12/2013 13:45'!
testGameWinnerAlt2
self setUpWithDifferentWinStrategy.
player2 addToPointsEarned: 10.
player3 addToPointsEarned: 9.
self standardTrickAndScorePhases.
self assert: (player1 gamesWon) = 0.
self assert: (player2 gamesWon) = 0.
self assert: (player3 gamesWon) = 0.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'MehrdadBiglari 7/23/2013 22:24'!
testGameWinnerMarginNotLargeEnough
self standardDealAndBidPhases.
player1 addToPointsEarned: 15.
player2 addToPointsEarned: 11.
self standardTrickAndScorePhases.
self assert: (player1 gamesWon) = 0.
self assert: (player2 gamesWon) = 0.
self assert: (player3 gamesWon) = 0.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/13/2013 09:38'!
testGameWinnerTeams
self teamDealAndBidPhases.
player1 addToPointsEarned: 15.
self teamTrickAndScorePhases.
self assert: (player1 gamesWon) = 1.
self assert: (player2 gamesWon) = 0.
self assert: (player3 gamesWon) = 1.
self assert: (player4 gamesWon) = 0.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/13/2013 12:07'!
testGameWinnerTeamsMarginNotLargeEnough
self teamDealAndBidPhases.
player3 addToPointsEarned: 15.
player4 addToPointsEarned: 10.
self teamTrickAndScorePhases.
self assert: (player1 gamesWon) = 0.
self assert: (player2 gamesWon) = 0.
self assert: (player3 gamesWon) = 0.
self assert: (player4 gamesWon) = 0.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/7/2013 17:09'!
testInvalidGameCreation
|player4 game|
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
player3:= SetbackPlayer name: 'Adam'.
player4:= SetbackPlayer name: 'Homer'.
game:= SetbackGame setUpStandardGame.
game addPlayer: player1.
self should: [ game startGame ] raise: TestResult error.
game addPlayer: player2.
game addPlayer: player3.
self should: [ game addPlayer: player4. ] raise: TestResult error.
self should: [ game startNewHand ] raise: TestResult error.
game startGame.
self should: [ game playerConfigStrategy: ThreePlayerStrategy new. ] raise: TestResult error.
self should: [ game winnerStrategy: StandardWinStrategy new. ] raise: TestResult error.
! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/27/2013 11:45'!
testPlayerDealing
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
hand:= SetbackGameHand players: ll playerConfig: nil winnerStrat: nil phaseOrder: (SetbackPhaseOrder new).
hand startNextPhase.
self assert: (player1 hand cards size) = 6.
self assert: (player2 hand cards size) = 6.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/12/2013 13:36'!
testSubsequentGames
self standardDealAndBidPhases.
self standardTrickAndScorePhases.
hand:= game startNewHand.
"ensure that the new hand is independent of the old hand"
self assert: hand trump = nil.
self assert: hand bidder = nil.
self assert: hand currentBid = nil.
self assert: hand currentPhase = nil.
self assert: hand players removeFirst pointsEarned ~= 0.! !

!SetbackGameTest methodsFor: 'tests' stamp: 'TerryTata 7/12/2013 13:36'!
testSubsequentGamesErrors
self standardDealAndBidPhases.
self standardTrickAndScorePhases.
self should: [ game addPlayer: player1] raise: TestResult error.
self should: [ game phaseOrder: player1] raise: TestResult error.
self should: [ game playerConfigStrategy: player1] raise: TestResult error.
self should: [ game winnerStrategy: player1] raise: TestResult error.
self should: [ game startGame] raise: TestResult error.! !

SetbackTestCase subclass: #SetbackPlayerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!SetbackPlayerTest methodsFor: 'tests' stamp: 'TerryTata 6/30/2013 09:32'!
testPlayerCreation
self assert: (SetbackPlayer name: 'Terry') name = 'Terry'.
self assert: (SetbackPlayer name: 'Terry') hand cards size = 0.
self assert: (SetbackPlayer name: 'Terry') pointsEarned = 0.
self assert: (SetbackPlayer name: 'Terry') cardsWon size = 0.! !

!SetbackPlayerTest methodsFor: 'tests' stamp: 'TerryTata 6/30/2013 16:24'!
testPlayerEquality
self assert: (SetbackPlayer name: 'Terry') ~= (SetbackPlayer name: 'Terry')! !

!SetbackPlayerTest methodsFor: 'tests' stamp: 'TerryTata 11/29/1999 16:52'!
testPlayerTeamAddition
| player4 team1 team2|
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Ramesh'.
player3:= SetbackPlayer name: 'Mehrdad'.
player4:= SetbackPlayer name: 'Adam'.
team1:= SetbackPlayerTeam new.
team2:= SetbackPlayerTeam new.
player1 joinTeam: team1.
player2 joinTeam: team2.
player3 joinTeam: team2.
player4 joinTeam: team1.
self assert: team1 players size = 2.
self assert: team2 players size = 2.
self assert: player1 currentTeam = player4 currentTeam.
self assert: player2 currentTeam = player3 currentTeam.
! !

!SetbackPlayerTest methodsFor: 'tests' stamp: 'TerryTata 11/29/1999 16:55'!
testPlayerTeamRemoval
| player4 team1 team2|
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Ramesh'.
player3:= SetbackPlayer name: 'Mehrdad'.
player4:= SetbackPlayer name: 'Adam'.
team1:= SetbackPlayerTeam new.
team2:= SetbackPlayerTeam new.
player1 joinTeam: team1.
player2 joinTeam: team2.
player3 joinTeam: team2.
player4 joinTeam: team1.
player1 leaveTeam.
player2 leaveTeam.
self assert: team1 players size = 1.
self assert: team2 players size = 1.
self assert: player1 currentTeam = player2 currentTeam.! !

!SetbackTestCase methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/12/2013 15:18'!
setUp
sortedDeck:= FrenchDeck new populateFrenchDeck.

player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
player3:= SetbackPlayer name: 'Adam'.
player4:= SetbackPlayer name: 'Bob'.

oneHeart:= SetbackPlayerHand addCard: (sortedDeck at: 1). "4 of diamonds"
oneHeart 
	addCard: (sortedDeck at: 2); " 4 of hearts"
	addCard: (sortedDeck at: 3); " 4 of clubs"
	addCard: (sortedDeck at: 4); " 4 of spades"
	addCard: (sortedDeck at: 5); "10 of diamonds"
	addCard: (sortedDeck at: 28). " king of spades"
	
oneDiamond:= SetbackPlayerHand addCard: (sortedDeck at: 50)."ace of hearts"
oneDiamond
	addCard: (sortedDeck at: 8); "10 of spades"
	addCard: (sortedDeck at: 41); "jack of diamonds"
	addCard: (sortedDeck at: 10); "2 of hearts"
	addCard: (sortedDeck at: 11); "2 of clubs"
	addCard: (sortedDeck at: 12). "2 of spades"
	
oneClub:= SetbackPlayerHand addCard: (sortedDeck at: 13). "5 of diamonds"
oneClub 
	addCard: (sortedDeck at: 14); "5 of hearts"
	addCard: (sortedDeck at: 15); "5 of clubs"
	addCard: (sortedDeck at: 16); "5 of spades"
	addCard: (sortedDeck at: 17); "8 of diamonds"
	addCard: (sortedDeck at: 18). "8 of hearts"
	
oneSpade:= SetbackPlayerHand addCard: (sortedDeck at: 19). "8 of clubs"
oneSpade 
	addCard: (sortedDeck at: 20); "8 of spades"
	addCard: (sortedDeck at: 21); "queen of diamonds"
	addCard: (sortedDeck at: 22); "queen of hearts"
	addCard: (sortedDeck at: 23); "queen of clubs"
	addCard: (sortedDeck at: 25). "king of diamonds"! !

SetbackTestCase subclass: #SetbackTrickTest
	instanceVariableNames: 'oneHeart oneClub oneDiamond oneSpade'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!SetbackTrickTest methodsFor: 'setUp' stamp: 'TerryTata 6/30/2013 12:11'!
setUp
super setUp.

oneHeart:= SetbackPlayerHand new.
oneHeart addCard: (sortedDeck at: 1);
	addCard: (sortedDeck at: 2);
	addCard: (sortedDeck at: 3);
	addCard: (sortedDeck at: 4);
	addCard: (sortedDeck at: 6);
	addCard: (sortedDeck at: 7).
	
oneDiamond:= SetbackPlayerHand new.
oneDiamond addCard: (sortedDeck at: 50);
	addCard: (sortedDeck at: 8);
	addCard: (sortedDeck at: 41);
	addCard: (sortedDeck at: 10);
	addCard: (sortedDeck at: 11);
	addCard: (sortedDeck at: 12).
	
oneClub:= SetbackPlayerHand new.
oneClub addCard: (sortedDeck at: 13);
	addCard: (sortedDeck at: 14);
	addCard: (sortedDeck at: 15);
	addCard: (sortedDeck at: 16);
	addCard: (sortedDeck at: 17);
	addCard: (sortedDeck at: 18).
	
oneSpade:= SetbackPlayerHand new.
oneSpade addCard: (sortedDeck at: 19);
	addCard: (sortedDeck at: 20);
	addCard: (sortedDeck at: 21);
	addCard: (sortedDeck at: 22);
	addCard: (sortedDeck at: 23);
	addCard: (sortedDeck at: 25).! !

!SetbackTrickTest methodsFor: 'tests' stamp: 'TerryTata 6/29/2013 21:17'!
testOpeningTrick
|trick|
"4 of hearts"
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 2) inHand: oneHeart.
"ace of hearts"
trick playCard: (sortedDeck at: 50) inHand: oneDiamond.
"5 of hearts"
trick playCard: (sortedDeck at: 14) inHand: oneClub.
"queen of hearts"
trick playCard: (sortedDeck at: 22) inHand: oneSpade.
self assert: trick leadCard suit = #hearts.
self assert: trick leadCard value = #four.
self assert: trick winningCard suit = #hearts.
self assert: trick winningCard value = #ace.
self assert: trick cards size = 4.
self assert: trick trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'tests' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCantFollowSuit
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 1) inHand: oneHeart.
trick playCard:  (sortedDeck at: 41) inHand: oneDiamond.
trick playCard: (sortedDeck at: 10) inHand: oneDiamond.
self assert: (trick cards size) = 3.
self assert: (trick leadCard) = (sortedDeck at: 1).
self assert: (trick trumpSuit) = (sortedDeck at: 1) suit.
self assert: (trick winningCard) =  (sortedDeck at: 41).! !

!SetbackTrickTest methodsFor: 'tests' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCardNotInHand
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 1) inHand: oneHeart.
trick playCard:  (sortedDeck at: 41) inHand: oneDiamond.
self should: [ trick playCard: (sortedDeck at: 52) inHand: oneDiamond. ] raise: TestResult error.! !

!SetbackTrickTest methodsFor: 'tests' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCreation
|trick|
trick:= SetbackTrick leadCard: (sortedDeck at: 50) inHand: oneDiamond. 
self assert: trick leadCard suit = #hearts.
self assert: trick leadCard value = #ace.
self assert: trick cards size = 1.! !

!SetbackTrickTest methodsFor: 'tests' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCreationNewGame
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 50) inHand: oneDiamond.
self assert: trick leadCard suit = #hearts.
self assert: trick leadCard value = #ace.
self assert: trick cards size = 1.
self assert: trick trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'tests' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickFailToFollowSuit
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 1) inHand: oneHeart. 
self should: [ trick playCard: (sortedDeck at: 10) inHand: oneDiamond ] raise: TestResult error.! !

!SetbackTrickTest methodsFor: 'tests' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickTrumpIn
|trick|
"Change trump to hearts"
SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 2) inHand: oneHeart.
"create a new trick and lead with 10 of clubs"
trick:= SetbackTrick leadCard: (sortedDeck at: 7) inHand: oneHeart.
"trump in with 5 of hearts"
trick playCard: (sortedDeck at: 14) inHand: oneClub.
"throw a club to follow suit"
trick playCard: (sortedDeck at: 19) inHand: oneSpade.
"throw another trump"
trick playCard: (sortedDeck at: 10) inHand: oneDiamond.
self assert: trick leadCard suit = #clubs.
self assert: trick leadCard value = #ten.
self assert: trick winningCard suit = #hearts.
self assert: trick winningCard value = #five.
self assert: trick cards size = 4.
self assert: trick trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'tests' stamp: 'TerryTata 6/30/2013 12:11'!
testTrickUniqueCards
|trick hand|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 50) inHand: oneDiamond. 
hand:= SetbackPlayerHand addCard: (sortedDeck at: 50).
self assert: (trick playCard: (sortedDeck at: 50) inHand: hand) cards size = 1.! !
